# MapboxImageryProvider

#### new Cesium.MapboxImageryProvider(options)
Scene/MapboxImageryProvider.js 55

  Provides tiled imagery hosted by Mapbox.

  Name | Type | Description
  --- | --- | ---

  `options`

  Object

  optional Object with the following properties:

  Name | Type | Default | Description
  --- | --- | --- | ---
  `url` | String | `'https://api.mapbox.com/v4/'` | optional The Mapbox server url.
  `mapId` | String |  | The Mapbox Map ID.
  `accessToken` | String |  | optional The public access token for the imagery.
  `format` | String | `'png'` | optional The format of the image request.
  `proxy` | Object |  | optional A proxy to use for requests. This object is expected to have a getURL function which returns the proxied URL.
  `ellipsoid` | Ellipsoid |  | optional The ellipsoid. If not specified, the WGS84 ellipsoid is used.
  `minimumLevel` | Number | `0` | optional The minimum level-of-detail supported by the imagery provider. Take care when specifying this that the number of tiles at the minimum level is small, such as four or less. A larger number is likely to result in rendering problems.
  `maximumLevel` | Number |  | optional The maximum level-of-detail supported by the imagery provider, or undefined if there is no limit.
  `rectangle` | Rectangle | `Rectangle.MAX_VALUE` | optional The rectangle, in radians, covered by the image.
  `credit` | Credit | String |  | optional A credit for the data source, which is displayed on the canvas.

  ##### Example:

      // Mapbox tile provider
      var mapbox = new Cesium.MapboxImageryProvider({
          mapId: 'mapbox.streets',
          accessToken: 'thisIsMyAccessToken'
      });

  ##### See:

  - https://www.mapbox.com/developers/api/maps/#tiles
  - https://www.mapbox.com/developers/api/#access-tokens

### Members

#### readonlycredit : Credit
Scene/MapboxImageryProvider.js 260

  Gets the credit to display when this imagery provider is active. Typically this is used to credit the source of the imagery. This function should not be called before `MapboxImageryProvider#ready` returns true.

#### readonlyerrorEvent : Event
Scene/MapboxImageryProvider.js 246

  Gets an event that is raised when the imagery provider encounters an asynchronous error.. By subscribing to the event, you will be notified of the error and can potentially recover from it. Event listeners are passed an instance of `TileProviderError`.

#### readonlyhasAlphaChannel : Boolean
Scene/MapboxImageryProvider.js 288

  Gets a value indicating whether or not the images provided by this imagery provider include an alpha channel. If this property is false, an alpha channel, if present, will be ignored. If this property is true, any images without an alpha channel will be treated as if their alpha is 1.0 everywhere. When this property is false, memory usage and texture upload time are reduced.

#### readonlymaximumLevel : Number
Scene/MapboxImageryProvider.js 187

  Gets the maximum level-of-detail that can be requested. This function should not be called before `MapboxImageryProvider#ready` returns true.

#### readonlyminimumLevel : Number
Scene/MapboxImageryProvider.js 204

  Gets the minimum level-of-detail that can be requested. This function should not be called before `MapboxImageryProvider#ready` returns true. Generally, a minimum level should only be used when the rectangle of the imagery is small enough that the number of tiles at the minimum level is small. An imagery provider with more than a few tiles at the minimum level will lead to rendering problems.

#### readonlyproxy : Proxy
Scene/MapboxImageryProvider.js 272

  Gets the proxy used by this provider.

#### readonlyready : Boolean
Scene/MapboxImageryProvider.js 123

  Gets a value indicating whether or not the provider is ready for use.

#### readonlyreadyPromise : Promise.<Boolean>
Scene/MapboxImageryProvider.js 135

  Gets a promise that resolves to true when the provider is ready for use.

#### readonlyrectangle : Rectangle
Scene/MapboxImageryProvider.js 148

  Gets the rectangle, in radians, of the imagery provided by the instance. This function should not be called before `MapboxImageryProvider#ready` returns true.

#### readonlytileDiscardPolicy : TileDiscardPolicy
Scene/MapboxImageryProvider.js 232

  Gets the tile discard policy. If not undefined, the discard policy is responsible for filtering out "missing" tiles via its shouldDiscardImage function. If this function returns undefined, no tiles are filtered. This function should not be called before `MapboxImageryProvider#ready` returns true.

#### readonlytileHeight : Number
Scene/MapboxImageryProvider.js 174

  Gets the height of each tile, in pixels. This function should not be called before `MapboxImageryProvider#ready` returns true.

#### readonlytileWidth : Number
Scene/MapboxImageryProvider.js 161

  Gets the width of each tile, in pixels. This function should not be called before `MapboxImageryProvider#ready` returns true.

#### readonlytilingScheme : TilingScheme
Scene/MapboxImageryProvider.js 217

  Gets the tiling scheme used by the provider. This function should not be called before `MapboxImageryProvider#ready` returns true.

#### readonlyurl : String
Scene/MapboxImageryProvider.js 111

  Gets the URL of the Mapbox server.

### Methods

#### getTileCredits(x, y, level) → Array.<Credit>
Scene/MapboxImageryProvider.js 305

  Gets the credits to be displayed when a given tile is displayed.

  Name | Type | Description
  --- | --- | ---
  `x` | Number | The tile X coordinate.
  `y` | Number | The tile Y coordinate.
  `level` | Number | The tile level;

  ##### Returns:

  The credits to be displayed when the tile is displayed.

  ##### Throws:

  - DeveloperError : `getTileCredits` must not be called before the imagery provider is ready.

#### pickFeatures(x, y, level, longitude, latitude) → Promise.<Array.<ImageryLayerFeatureInfo>>|undefined
Scene/MapboxImageryProvider.js 349

  Asynchronously determines what features, if any, are located at a given longitude and latitude within a tile. This function should not be called before `MapboxImageryProvider#ready` returns true. This function is optional, so it may not exist on all ImageryProviders.

  Name | Type | Description
  --- | --- | ---
  `x` | Number | The tile X coordinate.
  `y` | Number | The tile Y coordinate.
  `level` | Number | The tile level.
  `longitude` | Number | The longitude at which to pick features.
  `latitude` | Number | The latitude at which to pick features.

  ##### Returns:

  A promise for the picked features that will resolve when the asynchronous picking completes. The resolved value is an array of `ImageryLayerFeatureInfo` instances. The array may be empty if no features are found at the given location. It may also be undefined if picking is not supported.

  ##### Throws:

  - DeveloperError : `pickFeatures` must not be called before the imagery provider is ready.

#### requestImage(x, y, level) → Promise.<(Image|Canvas)>|undefined
Scene/MapboxImageryProvider.js 327

  Requests the image for a given tile. This function should not be called before `MapboxImageryProvider#ready` returns true.

  Name | Type | Description
  --- | --- | ---
  `x` | Number | The tile X coordinate.
  `y` | Number | The tile Y coordinate.
  `level` | Number | The tile level.

  ##### Returns:

  A promise for the image that will resolve when the image is available, or undefined if there are too many active requests to the server, and the request should be retried later. The resolved image may be either an Image or a Canvas DOM object.

  ##### Throws:

  - DeveloperError : `requestImage` must not be called before the imagery provider is ready.